'use strict';

exports.__esModule = true;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; };

exports.default = merge;
function mergeToTarget(target, src, _pushKeys) {
    var keys = Object.keys(src);
    for (var i = 0, j = keys.length; i < j; i++) {
        var key = keys[i];
        var val = src[key];
        if (val !== undefined) {
            if ((typeof val === 'undefined' ? 'undefined' : _typeof(val)) === 'object' && val !== null) {
                if (Array.isArray(val)) {
                    var arr = _pushKeys && _pushKeys.indexOf(key) !== -1 ? target[key] || [] : [];
                    target[key] = arr.concat(val);
                } else {
                    if (!target[key]) {
                        target[key] = {};
                    }
                    var pushKeys = void 0;
                    if (target[key].__push__) {
                        pushKeys = target[key].__push__;
                        delete target[key].__push__;
                    }
                    mergeToTarget(target[key], val, pushKeys);
                }
            } else {
                target[key] = val;
            }
        }
    }

    return target;
}

function merge() {
    var dest = {};

    for (var _len = arguments.length, objects = Array(_len), _key = 0; _key < _len; _key++) {
        objects[_key] = arguments[_key];
    }

    for (var i = 0, j = objects.length; i < j; i++) {
        mergeToTarget(dest, objects[i]);
    }

    return dest;
}
//# sourceMappingURL=merge.js.map